/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.dfareporting.model;

import com.google.api.client.json.GenericJson;

/**
 * Represents a response to the queryCompatibleFields method.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the DFA Reporting API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CompatibleFields extends GenericJson {

  /**
   * Contains items that are compatible to be selected for a report of type "CROSS_DIMENSION_REACH".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private CrossDimensionReachReportCompatibleFields crossDimensionReachReportCompatibleFields;

  /**
   * Contains items that are compatible to be selected for a report of type "FLOODLIGHT".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private FloodlightReportCompatibleFields floodlightReportCompatibleFields;

  /**
   * The kind of resource this is, in this case dfareporting#compatibleFields.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Contains items that are compatible to be selected for a report of type "PATH_TO_CONVERSION".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private PathToConversionReportCompatibleFields pathToConversionReportCompatibleFields;

  /**
   * Contains items that are compatible to be selected for a report of type "REACH".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ReachReportCompatibleFields reachReportCompatibleFields;

  /**
   * Contains items that are compatible to be selected for a report of type "STANDARD".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ReportCompatibleFields reportCompatibleFields;

  /**
   * Contains items that are compatible to be selected for a report of type "CROSS_DIMENSION_REACH".
   * The value returned may be {@code null}.
   */
  public CrossDimensionReachReportCompatibleFields getCrossDimensionReachReportCompatibleFields() {
    return crossDimensionReachReportCompatibleFields;
  }

  /**
   * Contains items that are compatible to be selected for a report of type "CROSS_DIMENSION_REACH".
   * The value set may be {@code null}.
   */
  public CompatibleFields setCrossDimensionReachReportCompatibleFields(CrossDimensionReachReportCompatibleFields crossDimensionReachReportCompatibleFields) {
    this.crossDimensionReachReportCompatibleFields = crossDimensionReachReportCompatibleFields;
    return this;
  }

  /**
   * Contains items that are compatible to be selected for a report of type "FLOODLIGHT".
   * The value returned may be {@code null}.
   */
  public FloodlightReportCompatibleFields getFloodlightReportCompatibleFields() {
    return floodlightReportCompatibleFields;
  }

  /**
   * Contains items that are compatible to be selected for a report of type "FLOODLIGHT".
   * The value set may be {@code null}.
   */
  public CompatibleFields setFloodlightReportCompatibleFields(FloodlightReportCompatibleFields floodlightReportCompatibleFields) {
    this.floodlightReportCompatibleFields = floodlightReportCompatibleFields;
    return this;
  }

  /**
   * The kind of resource this is, in this case dfareporting#compatibleFields.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * The kind of resource this is, in this case dfareporting#compatibleFields.
   * The value set may be {@code null}.
   */
  public CompatibleFields setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Contains items that are compatible to be selected for a report of type "PATH_TO_CONVERSION".
   * The value returned may be {@code null}.
   */
  public PathToConversionReportCompatibleFields getPathToConversionReportCompatibleFields() {
    return pathToConversionReportCompatibleFields;
  }

  /**
   * Contains items that are compatible to be selected for a report of type "PATH_TO_CONVERSION".
   * The value set may be {@code null}.
   */
  public CompatibleFields setPathToConversionReportCompatibleFields(PathToConversionReportCompatibleFields pathToConversionReportCompatibleFields) {
    this.pathToConversionReportCompatibleFields = pathToConversionReportCompatibleFields;
    return this;
  }

  /**
   * Contains items that are compatible to be selected for a report of type "REACH".
   * The value returned may be {@code null}.
   */
  public ReachReportCompatibleFields getReachReportCompatibleFields() {
    return reachReportCompatibleFields;
  }

  /**
   * Contains items that are compatible to be selected for a report of type "REACH".
   * The value set may be {@code null}.
   */
  public CompatibleFields setReachReportCompatibleFields(ReachReportCompatibleFields reachReportCompatibleFields) {
    this.reachReportCompatibleFields = reachReportCompatibleFields;
    return this;
  }

  /**
   * Contains items that are compatible to be selected for a report of type "STANDARD".
   * The value returned may be {@code null}.
   */
  public ReportCompatibleFields getReportCompatibleFields() {
    return reportCompatibleFields;
  }

  /**
   * Contains items that are compatible to be selected for a report of type "STANDARD".
   * The value set may be {@code null}.
   */
  public CompatibleFields setReportCompatibleFields(ReportCompatibleFields reportCompatibleFields) {
    this.reportCompatibleFields = reportCompatibleFields;
    return this;
  }

}
