/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.dfareporting.model;

import com.google.api.client.json.GenericJson;

/**
 * Represents a sorted dimension.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the DFA Reporting API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class SortedDimension extends GenericJson {

  /**
   * The kind of resource this is, in this case dfareporting#sortedDimension.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The name of the dimension.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String name;

  /**
   * An optional sort order for the dimension column, one of: - "ASCENDING"  - "DESCENDING"
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String sortOrder;

  /**
   * The kind of resource this is, in this case dfareporting#sortedDimension.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * The kind of resource this is, in this case dfareporting#sortedDimension.
   * The value set may be {@code null}.
   */
  public SortedDimension setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The name of the dimension.
   * The value returned may be {@code null}.
   */
  public String getName() {
    return name;
  }

  /**
   * The name of the dimension.
   * The value set may be {@code null}.
   */
  public SortedDimension setName(String name) {
    this.name = name;
    return this;
  }

  /**
   * An optional sort order for the dimension column, one of: - "ASCENDING"  - "DESCENDING"
   * The value returned may be {@code null}.
   */
  public String getSortOrder() {
    return sortOrder;
  }

  /**
   * An optional sort order for the dimension column, one of: - "ASCENDING"  - "DESCENDING"
   * The value set may be {@code null}.
   */
  public SortedDimension setSortOrder(String sortOrder) {
    this.sortOrder = sortOrder;
    return this;
  }

}
