/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.dfareporting.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * Represents a UserProfile resource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the DFA Reporting API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UserProfile extends GenericJson {

  /**
   * The account ID to which this profile belongs.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long accountId;

  /**
   * The account name this profile belongs to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String accountName;

  /**
   * The eTag of this response for caching purposes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String etag;

  /**
   * The kind of resource this is, in this case dfareporting#userProfile.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The unique ID of the user profile.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long profileId;

  /**
   * The sub account ID this profile belongs to if applicable.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long subAccountId;

  /**
   * The sub account name this profile belongs to if applicable.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String subAccountName;

  /**
   * The user name.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String userName;

  /**
   * The account ID to which this profile belongs.
   * The value returned may be {@code null}.
   */
  public Long getAccountId() {
    return accountId;
  }

  /**
   * The account ID to which this profile belongs.
   * The value set may be {@code null}.
   */
  public UserProfile setAccountId(Long accountId) {
    this.accountId = accountId;
    return this;
  }

  /**
   * The account name this profile belongs to.
   * The value returned may be {@code null}.
   */
  public String getAccountName() {
    return accountName;
  }

  /**
   * The account name this profile belongs to.
   * The value set may be {@code null}.
   */
  public UserProfile setAccountName(String accountName) {
    this.accountName = accountName;
    return this;
  }

  /**
   * The eTag of this response for caching purposes.
   * The value returned may be {@code null}.
   */
  public String getEtag() {
    return etag;
  }

  /**
   * The eTag of this response for caching purposes.
   * The value set may be {@code null}.
   */
  public UserProfile setEtag(String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * The kind of resource this is, in this case dfareporting#userProfile.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * The kind of resource this is, in this case dfareporting#userProfile.
   * The value set may be {@code null}.
   */
  public UserProfile setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The unique ID of the user profile.
   * The value returned may be {@code null}.
   */
  public Long getProfileId() {
    return profileId;
  }

  /**
   * The unique ID of the user profile.
   * The value set may be {@code null}.
   */
  public UserProfile setProfileId(Long profileId) {
    this.profileId = profileId;
    return this;
  }

  /**
   * The sub account ID this profile belongs to if applicable.
   * The value returned may be {@code null}.
   */
  public Long getSubAccountId() {
    return subAccountId;
  }

  /**
   * The sub account ID this profile belongs to if applicable.
   * The value set may be {@code null}.
   */
  public UserProfile setSubAccountId(Long subAccountId) {
    this.subAccountId = subAccountId;
    return this;
  }

  /**
   * The sub account name this profile belongs to if applicable.
   * The value returned may be {@code null}.
   */
  public String getSubAccountName() {
    return subAccountName;
  }

  /**
   * The sub account name this profile belongs to if applicable.
   * The value set may be {@code null}.
   */
  public UserProfile setSubAccountName(String subAccountName) {
    this.subAccountName = subAccountName;
    return this;
  }

  /**
   * The user name.
   * The value returned may be {@code null}.
   */
  public String getUserName() {
    return userName;
  }

  /**
   * The user name.
   * The value set may be {@code null}.
   */
  public UserProfile setUserName(String userName) {
    this.userName = userName;
    return this;
  }

}
